.\" SPDX-License-Identifier: BSD-2-Clause

.\" Copyright (c) 2022 Alessio Chiapperini

.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.

.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.

.Dd January 31, 2022
.Dt CONSUME 1
.Os
.Sh NAME
.Nm consume
.Nd split input, feed it into the given utility and consume it if successful.
.Sh SYNOPSIS
.Nm
.Op Fl \&0ach
.Op Fl i Ar file
.Op Fl v
.Op Ar utility Op Ar argument ...
.Sh DESCRIPTION
The
.Nm
utility reads input from the file named by the
.Ar file
operand or from stdin if absent, and splits it when encountering the given
delimiter (defaults to newline).
It then invokes the
.Ar utility
repeatedly, feeding it the generated data as input.
On success the given data is consumed (removed) from the input file, if any.
.Pp
The options are as follows:
.Bl -tag -width indent
.It Fl 0
Input items are teminated by a null character instead of by newline. The GNU
find -print0 option produces input suitable for this mode.
.It Fl a
Input items are fed as a command-line argument to
.Ar utility.
.It Fl c
Continue even if
.Ar utility
failed.
.It Fl h
Print usage information and exit.
.It Fl i Ar file
Read items from
.Ar file
instead of standard input.
.It Fl v
Print the command line on the standard error ouput before executing it.
.El
.Sh "EXIT STATUS"
The
.Nm
utility exits 0 on success, and 1 if an error occurs.
.Sh EXAMPLES
Count the number of words in each line of 'La Divina Commedia':
.Dl curl -s https://dmf.unicatt.it/~della/pythoncourse18/commedia.txt | consume wc -w
.Pp
Find files named
.Ar core
in or below the directory
.Ar /tmp
and delete them. Before deleting each file the full command is printed to stderr:
.Dl find /tmp -name core -type f -print | consume -a -v /bin/rm -f
.Pp
Consume all lines delimited by
.Sq 0
in biglistoflinks.txt that wget has downloaded successfully:
.Dl consume -0 -a -i biglistoflinks.txt wget -qc
.Sh SEE ALSO
.Xr split 1 ,
.Xr tee 1 ,
.Xr xargs 1
.Sh BUGS
.Bl -tag -width indent
.It Input lines are limited to LINE_MAX bytes in length.
.It Input file names are limited to BUFSIZ bytes in length.
.El
.Sh AUTHOR
.An Alessio Chiapperini Aq Mt alessio.chiapperini@\:nullbuffer.com 
